from collections.abc import Generator
from typing import NamedTuple

from _typeshed import Incomplete
from cmakelists_parsing import list_utils as list_utils

class QuotedString(NamedTuple):
    contents: Incomplete
    comments: Incomplete

class _Arg(NamedTuple):
    contents: Incomplete
    comments: Incomplete

class _Command(NamedTuple):
    name: Incomplete
    body: Incomplete
    comment: Incomplete

class BlankLine(NamedTuple): ...
class File(list): ...
class Comment(str): ...

def Arg(  # noqa:N802
    contents: object,
    comments: Incomplete | None = None,
) -> object: ...
def Command(  # noqa:N802
    name: object,
    body: object,
    comment: Incomplete | None = None,
) -> object: ...

class CMakeParseError(Exception): ...

def prettify(s: object) -> object: ...
def parse(s: object, path: str = "<string>") -> object: ...
def strip_blanks(tree: object) -> object: ...
def compose_lines(tree: object) -> Generator[Incomplete, None, None]: ...
def command_to_lines(cmd: object) -> object: ...
def arg_to_str(arg: object) -> object: ...
def parse_file(toks: object) -> Generator[Incomplete, None, None]: ...
def attach_comments_to_commands(nodes: object) -> object: ...
def command_then_comment(a: object, b: object) -> object: ...
def attach_comment_to_command(
    lnums_command: object,
    lnums_comment: object,
) -> object: ...
def parse_command(
    start_line_num: object,
    command_name: object,
    toks: object,
) -> object: ...
def expect(expected_type: object, toks: object) -> None: ...

scanner: Incomplete

def tokenize(s: object) -> Generator[Incomplete, None, None]: ...
